///////////////////////////////////////////////////////////////
//                                                           //
//  SparseMatrix.cpp                                         //
//                using a list instead of traditional matrix //
//                representation to represent sparse matrix  //
//                performance.								 //
//  v1.0                                                     //
//               Manual Page                                 //
//                                                           //
//  Author:      Jin,Jianxinag  Syracuse University          //
//  Language:    Visual C++, ver 6.0                         //
//  System:      Window NT, DOS 6.2                          //
//  Application: create a list to represent sparce matrix and//
//				 implement plus, minus, scalar multiplication//
//				 matrix multiplication, indexing, matrix     //
//				 inversion, read from and write to file.	 //
//                                                           //
//                                                           //
///////////////////////////////////////////////////////////////
#pragma warning(disable : 4786)
#include "SparseMatrix.h"
#include <iostream>   
using namespace std;

//-----------------------< test stub >------------------------------------

//#ifdef TEST_SPARSEMATRIX
void main(){
	cout<<"\n            SparseMatrix                       \n\n";
	cout<<"						       By   Jin,Jianxiang\n";
	cout<<" 					           jjin@npac.syr.edu\n\n\n";
	spMat <int>  matrix_1(3,3),matrix_2(3,3);	
	cout<<"\nDemo of read in range\n\n";
	matrix_1(2,1)=3;matrix_1(1,2)=4;
	cout<<"\nDemo of read out of range\n\n";
	spMat<int> matrix_copy(10,20);
	cout<<matrix_copy(30,5)<<"\n"<<"\nDemo of write out of range\n\n\n";
	matrix_copy(30,5)=1008;///////////////////
	cout<<"\nDemo of write in  range\n\n\n";
	matrix_copy(9,5)=1008;///////////////////
	matrix_2(1,1)=2;
	cout<<"\nDemo of operator *\n";
	spMat<int> testMul;
	testMul = matrix_1 * matrix_2;
	testMul.printOut();///////////////////
	cout<<"\nDemo of operator *\n";
	spMat<int> testScal;
	testScal = 10 * matrix_2;
	testScal.printOut();///////////////////
	cout<<"\nDemo of operator -\n";
	spMat<int> testSub;
	testSub = matrix_1 - matrix_2;
	testSub.printOut();///////////////////
	cout<<"\nDemo of operator +\n";
	spMat<int> testAdd;
	testAdd = matrix_1 + matrix_2;
	testAdd.printOut();///////////////////
	cout<<"\nDemo of save to & read from file\n";	
	testAdd.saveToFile("testAdd.dat");
	spMat<int> testRead;
	testRead.loadFromFile("testAdd.dat");
	testRead.printOut();
	return;
}

//#endif