#ifndef PROXY_H
#define PROXY_H
///////////////////////////////////////////////////////////////
//                                                           //
//		 proxy.h - using for general purpose for indexing    //
//                operator() to distinguish write from read  //
//				  value										 //
//  v1.0                                                     //
//               Manual Page                                 //
//                                                           //
//  Language:    Visual C++, ver 6.0                         //
//  System:      Window NT, DOS 6.2                          //
//  Application - using for general purpose for indexing     //
//                operator ()  to distinguish write from read//
//				  value										 //
//  Author:      Jianxiang Jin   Syracuse University         //
//				 jjin@npac.syr.edu							 //
//                                                           //
///////////////////////////////////////////////////////////////
/*

  Module INDEXPROXY - usE for general purpose for indexing    
	                  operator () to distinguish write from read
					  value										 
  Keywords:
  =========
	
*/

///////////////////////////////////////////////////////////////
//                                                           //
//               Maintenance Page                            //
//                                                           //
///////////////////////////////////////////////////////////////
//                                                           //
//  Build Process                                            //
//                                                           //
//  Files Required:											 //	
//	proxy.h proxy.cpp										 //	
//	Integrated Environment:                                  //
//  - close any open project                                 //
//  - set Options/Compiler/Code generation/defines: to       //
//    TEST_PROXY		                                     //
//  - run                                                    //
//                                                           //
//  Command Line Compiler:                                   //
//    bcc -w+ -DTEST_PROXY proxy.cpp						 //
//                                                           //
///////////////////////////////////////////////////////////////
/*

  History:
  ========
  v1.0 : 14 March, 98
  - fixed bug in operator()(); 
*/
///////////////////////////////////////////////////////////////
//                                                           //
//               Declarations                                //
//                                                           //
///////////////////////////////////////////////////////////////
#include <iostream>
using namespace std;

template <class T, class P> class proxy{

private:
	void (P::*pWriteFunction)(T);//pointer of function to write
	T (P::*pReadFunction)();     //pointer of function to read
	P * pNode;                   //pointer of Node in matrix

public:
	proxy();
	~proxy();
	proxy(void (P::*_write)(T), T (P::*_read)(), P * p);

	
	void operator=(const T t);
	operator const T();
};

template<class T, class P>  proxy<T,P>::proxy(){
}
template<class T, class P>  proxy<T,P>::~proxy(){
}
template<class T, class P>	proxy<T,P>::proxy(void (P::*_write)(T), T (P::*_read)(), P * p):pWriteFunction(_write), pReadFunction(_read), pNode(p){
}

template<class T, class P>  void proxy<T,P>::operator=(const T t){
	if(pNode==NULL){
		cout<<"Index out of range,proxy fails to write \n";
	}
	else (pNode->*pWriteFunction)(t);
}

template<class T, class P>	proxy<T,P>::operator const T(){
	if(pNode==NULL){
		cout<<"Index out of range,proxy fails to read \n";
		return -10000000;
	}
	return (pNode->*pReadFunction)();
}


#endif
